#!/bin/sh

. ./common/ajax_common


alertConf="${IXCACHEPATH}/etc/wx_alert.conf"
snameConf="${IXCACHEPATH}/etc/sysname.conf"

apifile="${IXCACHEPATH}/tmp/wxpush.log"
wxpush_uri="http://weixin.panabit.com/webappwx/wxpush.php"

ALERT="${IXCACHEPATH}/bin/weixin_alert"


load_alert_conf()
{
	license=1
	newver=1
	no_req=1
	no_dow=1
	no_out=1
	dmesg=1
	SYSNAME=""
	tm_start=0
	tm_end=0
	wx_enable=0

	[ -f ${alertConf} ] && . ${alertConf}
	[ -f ${snameConf} ] && . ${snameConf}

	printf "{"
	printf "\"sysname\":\"${SYSNAME}\","
	printf "\"license\":${license},"
	printf "\"newver\":${newver},"
	printf "\"no_req\":${no_req},"
	printf "\"no_dow\":${no_dow},"
	printf "\"no_out\":${no_out},"
	printf "\"dmesg\":${dmesg},"
	printf "\"tm_start\":${tm_start},"
	printf "\"tm_end\":${tm_end},"
	printf "\"enable\":${wx_enable}"
	printf "}"
}


set_alert_conf()
{
	mkdir -p ${IXCACHEPATH}/etc/
	
	if [ ${CGI_tm_start} -gt ${CGI_tm_end} ]; then
		retjson 1 "ʼʱ䲻ܴڽʱ"
	fi

	echo "license=${CGI_license}" > ${alertConf}
	echo "newver=${CGI_newver}" >> ${alertConf}
	echo "no_req=${CGI_no_req}" >> ${alertConf}
	echo "no_dow=${CGI_no_dow}" >> ${alertConf}
	echo "no_out=${CGI_no_out}" >> ${alertConf}
	echo "dmesg=${CGI_dmesg}" >> ${alertConf}
	echo "tm_start=${CGI_tm_start}" >> ${alertConf}
	echo "tm_end=${CGI_tm_end}" >> ${alertConf}
	echo "wx_enable=${CGI_enable}" >> ${alertConf}

	echo "SYSNAME=${CGI_sysname}" > ${snameConf}

	for pid in `ps -ax | grep weixin_alert | grep -v grep | awk '{print $1}'`
	do
		kill -9 ${pid} >/dev/null 2>&1
	done
	
	if  [ "${CGI_enable}" = "1" ]; then
		${ALERT} >/dev/null 2>&1 &
	fi

	sync
	retjson 0 "óɹ"
}


query_weixin_user()
{
	License=`ixeye key get`
    api="${wxpush_uri}?act=info&app=iXCache&guid=${License}&result=json"
    fetch ${api} -o ${apifile} >/dev/null 2>&1

	if [ ! -f ${apifile} ]; then
		printf "[]"
	else
		cat ${apifile}
	fi
}


unbind_weixin_user()
{
	id=$1
	License=`ixeye key get`
    api="${wxpush_uri}?act=rmv&app=iXCache&guid=${License}&id=${CGI_id}"
    fetch ${api} -o ${apifile}  >/dev/null 2>&1

    [ ! -f ${apifile} ] && retjson 1 "ʧ"
	
	errmsg=`cat ${apifile} | grep "OK"`
	if [ "${errmsg}" != "" ]; then
		retjson 0 "ɹ"
	else
		retjson 1 "ʧ"
	fi
}


case "${CGI_action}" in
	"load_alert_conf")
		print_json_head
		load_alert_conf
		;;
	
	"set_alert_conf")
		set_alert_conf
		;;

	"query_weixin_user")
		print_json_head
		query_weixin_user
		;;
		
	"unbind_weixin_user")
		unbind_weixin_user
		;;

	*)
		retjson 1 "UNKNOW_ACTION"
		;;
esac
